Package oracle.sql

## Class TIMESTAMPTZ

- java.lang.Object
- - oracle.sql.Datum
  - - oracle.sql.TIMESTAMPTZ

All Implemented Interfaces:
  `java.io.Serializable`, `oracle.jdbc.internal.OracleTimestampWithTimeZone`

    public class TIMESTAMPTZ
    extends Datum
    implements oracle.jdbc.internal.OracleTimestampWithTimeZone

TIMESTAMPTZ Class

The `TIMESTAMPTZ` class provides conversions between the Oracle Date (ldx_t) data type and Java classes `java.sql.Date`, `java.sql.Time`, `java.sql.Timestamp`

The internal data for this object is stored as a thirteen byte array in the super class' storage area. The bytes are arranged as follows:

          Byte       Represents
           0         Century (119 for 1990)
           1         Decade  (190 for 1990)
           2         Month
           3         Day
           4         Hour
           5         Minute
           6         Seconds
           7         Nanoseconds (Most Significant bit)
           8         Nanoseconds
           9         Nanoseconds
           10        Nanoseconds (Least Significant Bit)
           11,12     Region id or Timezone Hour/Minute

The timezone information is stored as an offset in the RegionID format or in the HOUR/MINUTE format

Static methods are used for conversions.

See Also:
  Serialized Form

### Field Summary

### Fields inherited from class oracle.sql.Datum

`ojiOracleDatumWithConnection, targetDatum`

### Constructor Summary

Constructors
`TIMESTAMPTZ()` Constructs a TIMESTAMPTZ object initialized to 1/1/1970.
`TIMESTAMPTZ​(byte[] timestamptz)` Create an Oracle TIMESTAMPTZ object represented by the given Oracle Timestamptz
`TIMESTAMPTZ​(java.sql.Connection conn, java.lang.String str)` Create a TIMESTAMPTZ object given a Java String object.
`TIMESTAMPTZ​(java.sql.Connection conn, java.lang.String str, java.util.Calendar cal)` Create a TIMESTAMPTZ object given a Java String object.
`TIMESTAMPTZ​(java.sql.Connection conn, java.sql.Date date)` Create an Oracle TIMESTAMPTZ object represented by the Java Date
`TIMESTAMPTZ​(java.sql.Connection conn, java.sql.Date date, java.util.Calendar cal)` Create an Oracle TIMESTAMPTZ object represented by the Java Date and the Java Calendar object
`TIMESTAMPTZ​(java.sql.Connection conn, java.sql.Time time)` Create an Oracle TIMESTAMPTZ object represented by the given Java Time
`TIMESTAMPTZ​(java.sql.Connection conn, java.sql.Time time, java.util.Calendar cal)` Create an Oracle TIMESTAMPTZ object represented by the given Java Time and the Java Calendar object
`TIMESTAMPTZ​(java.sql.Connection conn, java.sql.Timestamp timestamp)` Create an Oracle TIMESTAMPTZ object represented by the Java Timestamp
`TIMESTAMPTZ​(java.sql.Connection conn, java.sql.Timestamp timestamp, java.time.ZoneId tzid)` Create an Oracle TIMESTAMPTZ object represented by the Java Timestamp with the specified ZoneId.
`TIMESTAMPTZ​(java.sql.Connection conn, java.sql.Timestamp timestamp, java.util.Calendar cal)` Create an Oracle TIMESTAMPTZ object represented by the Java Timestamp and the Java Calendar object
`TIMESTAMPTZ​(java.sql.Connection conn, java.time.LocalDateTime ldt)` Create a TIMESTAMPTZ object given a Java LocalDateTime object.
`TIMESTAMPTZ​(java.sql.Connection conn, DATE date)` Create an Oracle TIMESTAMPTZ object represented by the Oracle DATE
`TIMESTAMPTZ​(java.time.OffsetDateTime odt)` Create a TIMESTAMPTZ object given a Java OffsetDateTime object.
`TIMESTAMPTZ​(java.time.OffsetTime ot)` Create a TIMESTAMPTZ object given a Java OffsetTime object.
`TIMESTAMPTZ​(java.time.ZonedDateTime zdt)` Create a TIMESTAMPTZ object given a Java ZonedDateTime object.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`java.sql.Date` `dateValue​(java.sql.Connection conn)` Calls toDate to convert internal Oracle TIMESTAMPTZ to a Java Date.
`java.util.TimeZone` `getTimeZone()`
`boolean` `isConvertibleTo​(java.lang.Class<?> cls)` Determines if the object can be converted to a particular class
`java.time.LocalDateTime` `localDateTimeValue()` Calls toLocalDateTime to convert internal Oracle TIMESTAMPTZ to a Java LocalDateTime.
`java.lang.Object` `makeJdbcArray​(int arraySize)` Returns a JDBC array representation of the datum
`static TIMESTAMPTZ` `of​(java.sql.Connection conn, java.time.LocalDateTime ldt)` Creates TIMESTAMPTZ from the LocalDateTime.
`static TIMESTAMPTZ` `of​(java.time.OffsetDateTime odt)` Creates TIMESTAMPTZ from the OffsetDateTime.
`static TIMESTAMPTZ` `of​(java.time.ZonedDateTime zdt)` Creates TIMESTAMPTZ from the ZonedDateTime.
`java.time.OffsetDateTime` `offsetDateTimeValue()` Calls toOffsetDateTime to convert internal Oracle TIMESTAMPTZ to a Java OffsetDateTime without a connection object.
`java.time.OffsetDateTime` `offsetDateTimeValue​(java.sql.Connection conn)` Calls toOffsetDateTime to convert internal Oracle TIMESTAMPTZ to a Java OffsetDateTime with a connection object.
`java.lang.String` `stringValue​(java.sql.Connection conn)` Calls toString to convert internal Oracle TIMESTAMPTZ to a Java String.
`java.sql.Timestamp` `timestampValue​(java.sql.Connection conn)` Calls toTimestamp to convert internal Oracle Date to a Java Timestamp.
`java.sql.Time` `timeValue​(java.sql.Connection conn)` Calls toTime to convert internal Oracle Date to a Java Time.
`byte[]` `toBytes()` Convert Oracle Timestamptz object into a byte array
`static byte[]` `toBytes​(java.sql.Connection conn, java.lang.String str)` Convert Java String to Oracle TIMESTAMPTZ.
`static byte[]` `toBytes​(java.sql.Connection conn, java.lang.String str, java.util.Calendar cal)` Convert Java String to Oracle TIMESTAMPTZ.
`static byte[]` `toBytes​(java.sql.Connection conn, java.sql.Date date)` Convert Java Date to Oracle TIMESTAMPTZ.
`static byte[]` `toBytes​(java.sql.Connection conn, java.sql.Date date, java.util.Calendar cal)` Convert Java Date to Oracle TIMESTAMPTZ.
`static byte[]` `toBytes​(java.sql.Connection conn, java.sql.Time time)` Convert Java Time to Oracle TIMESTAMPTZ.
`static byte[]` `toBytes​(java.sql.Connection conn, java.sql.Time time, java.util.Calendar cal)` Convert Java Time to Oracle TIMESTAMPTZ.
`static byte[]` `toBytes​(java.sql.Connection conn, java.sql.Timestamp timestamp)` Convert Java Timestamp to Oracle TIMESTAMPTZ
`static byte[]` `toBytes​(java.sql.Connection conn, java.sql.Timestamp timestamp, java.time.ZoneId tzid)` Convert Java Timestamp to Oracle TIMESTAMPTZ
`static byte[]` `toBytes​(java.sql.Connection conn, java.sql.Timestamp timestamp, java.util.Calendar cal)` Convert Java Timestamp to Oracle TIMESTAMPTZ
`static byte[]` `toBytes​(java.sql.Connection conn, java.time.LocalDateTime ldt)` Convert Java LocalDateTime to Oracle TIMESTAMPTZ.
`static byte[]` `toBytes​(java.sql.Connection conn, DATE date)` Convert Oracle DATE to Oracle TIMESTAMPTZ
`static byte[]` `toBytes​(java.time.OffsetDateTime odt)` Convert Java OffsetDateTime to Oracle TIMESTAMPTZ.
`static byte[]` `toBytes​(java.time.OffsetTime ot)` Convert Java OffsetTime to Oracle TIMESTAMPTZ.
`static byte[]` `toBytes​(java.time.ZonedDateTime zdt)` Convert Java ZonedDateTime to Oracle TIMESTAMPTZ.
`static java.sql.Date` `toDate​(java.sql.Connection conn, byte[] timestamptz)` Convert a byte array representing a TIMESTAMPTZ object to a Java Date Object
`static DATE` `toDATE​(java.sql.Connection conn, byte[] timestamptz)` Convert a byte array representing a TIMESTAMPTZ object to a Oracle DATE Object
`static java.sql.Date` `toDate2​(java.sql.Connection conn, byte[] timestamptz)` Convert a byte array representing a TIMESTAMPTZ object to a Java Date Object in accordance with java.sql.Date specification.
`java.lang.Object` `toJdbc()` Returns the JDBC representation of the timestamptz object
`java.time.LocalDateTime` `toLocalDateTime()` Converts TIMESTAMPTZ to LocalDateTime.
`static java.time.LocalDateTime` `toLocalDateTime​(byte[] timestamptz)` Converts TIMESTAMPTZ to LocalDateTime.
`java.time.OffsetDateTime` `toOffsetDateTime()` Converts TIMESTAMPTZ to OffsetDateTime.
`static java.time.OffsetDateTime` `toOffsetDateTime​(java.sql.Connection conn, byte[] timestamptz)` Converts a TIMESTAMPTZ to an OffsetDateTime
`java.time.OffsetTime` `toOffsetTime()` Converts a TIMESTAMPTZ to an OffsetTime
`static java.lang.String` `toString​(java.sql.Connection conn, byte[] timestamptz)` Converts a TIMESTAMPTZ to a string
`static java.sql.Time` `toTime​(java.sql.Connection conn, byte[] timestamptz)` Convert a byte array representing a TIMESTAMPTZ object to a Java Time Object
`static java.sql.Timestamp` `toTimestamp​(java.sql.Connection conn, byte[] timestamptz)` Convert a byte array representing a TIMESTAMP WITH TIME ZONE object to a Java Timestamp Object
`static TIMESTAMP` `toTIMESTAMP​(java.sql.Connection conn, byte[] timestamptz)` Convert a byte array representing a TIMESTAMPTZ object to a Oracle TIMESTAMP Object
`static java.sql.Timestamp` `toTimestamp2​(java.sql.Connection conn, byte[] timestamptz)` Convert a byte array representing a TIMESTAMPTZ object to a Java Timestamp Object
`java.time.ZonedDateTime` `toZonedDateTime()` Converts TIMESTAMPTZ to ZonedDateTime.
`static java.time.ZonedDateTime` `toZonedDateTime​(byte[] timestamptz)` Converts TIMESTAMPTZ to ZonedDateTime.
`java.time.ZonedDateTime` `zonedDateTimeValue()` Calls toZonedDateTime to convert internal Oracle TIMESTAMPTZ to a Java ZonedDateTime.

### Methods inherited from class oracle.sql.Datum

`asciiStreamValue, bigDecimalValue, binaryStreamValue, booleanValue, bytesEqual, bytesHashCode, byteValue, characterStreamValue, compareBytes, dateValue, doubleValue, equals, floatValue, getBytes, getConnectionDuringExceptionHandling, getLength, getStream, intValue, isNull, longValue, setBytes, setShareBytes, shareBytes, stringValue, timestampValue, timestampValue, timeValue, timeValue, toClass`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### TIMESTAMPTZ

    public TIMESTAMPTZ()

Constructs a TIMESTAMPTZ object initialized to 1/1/1970.

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(byte[] timestamptz)

Create an Oracle TIMESTAMPTZ object represented by the given Oracle Timestamptz

Parameters:
  `timestamptz` - Oracle TIMESTAMPTZ

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       java.sql.Date date)
                throws java.sql.SQLException

Create an Oracle TIMESTAMPTZ object represented by the Java Date

Parameters:
  `conn` - JDBC connection date Java Date object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       java.sql.Date date,
                       java.util.Calendar cal)
                throws java.sql.SQLException

Create an Oracle TIMESTAMPTZ object represented by the Java Date and the Java Calendar object

Parameters:
  `conn` - JDBC connection date Java Date object cal java Calendar object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       java.sql.Time time)
                throws java.sql.SQLException

Create an Oracle TIMESTAMPTZ object represented by the given Java Time

Parameters:
  `conn` - JDBC connection time Java Time object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       java.sql.Time time,
                       java.util.Calendar cal)
                throws java.sql.SQLException

Create an Oracle TIMESTAMPTZ object represented by the given Java Time and the Java Calendar object

Parameters:
  `conn` - JDBC connection time Java Time object cal java Calendar object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       java.sql.Timestamp timestamp)
                throws java.sql.SQLException

Create an Oracle TIMESTAMPTZ object represented by the Java Timestamp

Parameters:
  `conn` - JDBC connection timestamp Java Timestamp object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       java.sql.Timestamp timestamp,
                       java.util.Calendar cal)
                throws java.sql.SQLException

Create an Oracle TIMESTAMPTZ object represented by the Java Timestamp and the Java Calendar object

Parameters:
  `conn` - JDBC connection timestamp Java Timestamp object cal Java Calendar object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       java.sql.Timestamp timestamp,
                       java.time.ZoneId tzid)
                throws java.sql.SQLException

Create an Oracle TIMESTAMPTZ object represented by the Java Timestamp with the specified ZoneId.

Parameters:
  `conn` - JDBC connection timestamp Java Timestamp object tzidstamp Java ZoneId object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       DATE date)
                throws java.sql.SQLException

Create an Oracle TIMESTAMPTZ object represented by the Oracle DATE

Parameters:
  `conn` - JDBC connection date Oracle DATE object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       java.lang.String str)
                throws java.sql.SQLException

Create a TIMESTAMPTZ object given a Java String object.

Parameters:
  `conn` - JDBC connection str Java String object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       java.lang.String str,
                       java.util.Calendar cal)
                throws java.sql.SQLException

Create a TIMESTAMPTZ object given a Java String object.

Parameters:
  `conn` - JDBC connection str Java String object cal Calendar object encapsulating the timezone
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.time.OffsetDateTime odt)
                throws java.sql.SQLException

Create a TIMESTAMPTZ object given a Java OffsetDateTime object.

Parameters:
  `odt` - OffsetDateTime object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.time.ZonedDateTime zdt)
                throws java.sql.SQLException

Create a TIMESTAMPTZ object given a Java ZonedDateTime object.

Parameters:
  `zdt` - ZonedDateTime object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.sql.Connection conn,
                       java.time.LocalDateTime ldt)
                throws java.sql.SQLException

Create a TIMESTAMPTZ object given a Java LocalDateTime object.

Parameters:
  `ldt` - LocalDateTime object
Throws:
  `java.sql.SQLException`

#### TIMESTAMPTZ

    public TIMESTAMPTZ​(java.time.OffsetTime ot)
                throws java.sql.SQLException

Create a TIMESTAMPTZ object given a Java OffsetTime object.

Parameters:
  `ot` - OffsetTime object
Throws:
  `java.sql.SQLException`

### Method Detail

#### toDate

    public static java.sql.Date toDate​(java.sql.Connection conn,
                                       byte[] timestamptz)
                                throws java.sql.SQLException

Convert a byte array representing a TIMESTAMPTZ object to a Java Date Object

Parameters:
  `conn` - JDBC connection timestamptz Oracle TIMESTAMPTZ object
Returns:
  the Java Date object represented by Oracle TIMESTAMPTZ object
Throws:
  `java.sql.SQLException`

#### toDate2

    public static java.sql.Date toDate2​(java.sql.Connection conn,
                                        byte[] timestamptz)
                                 throws java.sql.SQLException

Convert a byte array representing a TIMESTAMPTZ object to a Java Date Object in accordance with java.sql.Date specification.

Parameters:
  `conn` - JDBC connection timestamptz Oracle TIMESTAMPTZ object in byte array
Returns:
  the Java Date object represented by Oracle TIMESTAMPTZ object as per java.sql.Date standards. i.e w.r.t GMT timezone
Throws:
  `java.sql.SQLException`

#### toTime

    public static java.sql.Time toTime​(java.sql.Connection conn,
                                       byte[] timestamptz)
                                throws java.sql.SQLException

Convert a byte array representing a TIMESTAMPTZ object to a Java Time Object

Parameters:
  `conn` - JDBC connection timestamptz Oracle TIMESTAMPTZ object
Returns:
  the java.sql.Time object represented by Oracle TIMESTAMPTZ object. Only the hour, minute and seconds are contained in the java.sql.Time object that is returned and hence callers should not attempt to access the date component of the returned object.
Throws:
  `java.sql.SQLException`

#### toDATE

    public static DATE toDATE​(java.sql.Connection conn,
                              byte[] timestamptz)
                       throws java.sql.SQLException

Convert a byte array representing a TIMESTAMPTZ object to a Oracle DATE Object

Parameters:
  `conn` - JDBC connection timestamptz Oracle TIMESTAMPTZ object
Returns:
  the oracle DATE object represented by Oracle TIMESTAMPTZ object
Throws:
  `java.sql.SQLException`

#### toTIMESTAMP

    public static TIMESTAMP toTIMESTAMP​(java.sql.Connection conn,
                                        byte[] timestamptz)
                                 throws java.sql.SQLException

Convert a byte array representing a TIMESTAMPTZ object to a Oracle TIMESTAMP Object

Parameters:
  `conn` - JDBC connection timestamptz Oracle TIMESTAMPTZ object
Returns:
  the Oracle TIMESTAMP object represented by Oracle TIMESTAMPTZ object
Throws:
  `java.sql.SQLException`

#### toTimestamp

    public static java.sql.Timestamp toTimestamp​(java.sql.Connection conn,
                                                 byte[] timestamptz)
                                          throws java.sql.SQLException

Convert a byte array representing a TIMESTAMP WITH TIME ZONE object to a Java Timestamp Object

Parameters:
  `conn` - JDBC connection timestamptz Oracle TIMESTAMPTZ object
Returns:
  the Java Timestamp object represented by Oracle TIMESTAMPTZ object
Throws:
  `java.sql.SQLException`

#### toTimestamp2

    public static java.sql.Timestamp toTimestamp2​(java.sql.Connection conn,
                                                  byte[] timestamptz)
                                           throws java.sql.SQLException

Convert a byte array representing a TIMESTAMPTZ object to a Java Timestamp Object

Parameters:
  `conn` - JDBC connection timestamptz Oracle TIMESTAMPTZ object
Returns:
  the Java Timestamp object represented by Oracle TIMESTAMPTZ object
Throws:
  `java.sql.SQLException`

#### toString

    public static java.lang.String toString​(java.sql.Connection conn,
                                            byte[] timestamptz)
                                     throws java.sql.SQLException

Converts a TIMESTAMPTZ to a string

Parameters:
  `timestamptz` - a byte array
Returns:
  String representing the TIMESTAMPTZ
Throws:
  `java.sql.SQLException`

#### toOffsetDateTime

    public static java.time.OffsetDateTime toOffsetDateTime​(java.sql.Connection conn,
                                                            byte[] timestamptz)
                                                     throws java.sql.SQLException

Converts a TIMESTAMPTZ to an OffsetDateTime

Parameters:
  `timestamptz` - a byte array
Returns:
  OffsetDateTime representing the TIMESTAMPTZ
Throws:
  `java.sql.SQLException`

#### timestampValue

    public java.sql.Timestamp timestampValue​(java.sql.Connection conn)
                                      throws java.sql.SQLException

Calls toTimestamp to convert internal Oracle Date to a Java Timestamp.

Returns:
  a Java Timestamp value
Throws:
  `java.sql.SQLException`

#### toBytes

    public byte[] toBytes()

Convert Oracle Timestamptz object into a byte array

Specified by:
  `toBytes` in interface `oracle.jdbc.internal.OracleTimestampWithTimeZone`
Returns:
  the byte array stored in the TIMESTAMPTZ object

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 java.sql.Date date)
                          throws java.sql.SQLException

Convert Java Date to Oracle TIMESTAMPTZ.

Parameters:
  `conn` - JDBC connection date Java Date object
Returns:
  the byte array representing the java Date.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 java.sql.Date date,
                                 java.util.Calendar cal)
                          throws java.sql.SQLException

Convert Java Date to Oracle TIMESTAMPTZ.

Parameters:
  `conn` - JDBC connection date Java Date object cal java Calendar object
Returns:
  the byte array representing the java Date.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 java.sql.Time time)
                          throws java.sql.SQLException

Convert Java Time to Oracle TIMESTAMPTZ.

Parameters:
  `conn` - JDBC connection time Java Time object
Returns:
  the byte array representing the java Time.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 java.sql.Time time,
                                 java.util.Calendar cal)
                          throws java.sql.SQLException

Convert Java Time to Oracle TIMESTAMPTZ.

Parameters:
  `conn` - JDBC connection time Java Time object cal java Calendar object
Returns:
  the byte array representing the java Time.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 java.sql.Timestamp timestamp)
                          throws java.sql.SQLException

Convert Java Timestamp to Oracle TIMESTAMPTZ

Parameters:
  `conn` - JDBC connection timestamp Java Timestamp object
Returns:
  the byte array representing the TIMESTAMPTZ object.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 java.sql.Timestamp timestamp,
                                 java.util.Calendar cal)
                          throws java.sql.SQLException

Convert Java Timestamp to Oracle TIMESTAMPTZ

Parameters:
  `conn` - JDBC connection timestamp Java Timestamp object cal Java Calendar object
Returns:
  the byte array representing the TIMESTAMPTZ object.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 java.sql.Timestamp timestamp,
                                 java.time.ZoneId tzid)
                          throws java.sql.SQLException

Convert Java Timestamp to Oracle TIMESTAMPTZ

Parameters:
  `conn` - JDBC connection timestamp Java Timestamp object tzid Java ZoneId object
Returns:
  the byte array representing the TIMESTAMPTZ object.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 DATE date)
                          throws java.sql.SQLException

Convert Oracle DATE to Oracle TIMESTAMPTZ

Parameters:
  `conn` - JDBC connection date Oracle DATE object
Returns:
  the byte array representing the Oracle TIMESTAMPTZ.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 java.lang.String str)
                          throws java.sql.SQLException

Convert Java String to Oracle TIMESTAMPTZ.

Parameters:
  `conn` - JDBC Connection str java.lang.String object to be converted.
Returns:
  the byte array representing the input string.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 java.lang.String str,
                                 java.util.Calendar cal)
                          throws java.sql.SQLException

Convert Java String to Oracle TIMESTAMPTZ.

Parameters:
  `conn` - JDBC Connection str java.lang.String object to be converted. cal Calendar object encapsulating the timezone
Returns:
  the byte array representing the input string.
Throws:
  `java.sql.SQLException`

#### stringValue

    public java.lang.String stringValue​(java.sql.Connection conn)
                                 throws java.sql.SQLException

Calls toString to convert internal Oracle TIMESTAMPTZ to a Java String.

Specified by:
  `stringValue` in interface `oracle.jdbc.internal.OracleTimestampWithTimeZone`
Overrides:
  `stringValue` in class `Datum`
Parameters:
  `conn` - oracle.JDBC.OracleConnection object
Returns:
  a Java String value
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.time.OffsetDateTime odt)
                          throws java.sql.SQLException

Convert Java OffsetDateTime to Oracle TIMESTAMPTZ.

Parameters:
  `odt` - OffsetDateTime object
Returns:
  the byte array representing the java Date.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.time.ZonedDateTime zdt)
                          throws java.sql.SQLException

Convert Java ZonedDateTime to Oracle TIMESTAMPTZ.

Parameters:
  `zdt` - ZonedDateTime object
Returns:
  the byte array representing the java Date.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.sql.Connection conn,
                                 java.time.LocalDateTime ldt)
                          throws java.sql.SQLException

Convert Java LocalDateTime to Oracle TIMESTAMPTZ.

Parameters:
  `zdt` - LocalDateTime object
Returns:
  the byte array representing the java Date.
Throws:
  `java.sql.SQLException`

#### toBytes

    public static byte[] toBytes​(java.time.OffsetTime ot)
                          throws java.sql.SQLException

Convert Java OffsetTime to Oracle TIMESTAMPTZ.

Parameters:
  `ot` - OffsetTime object
Returns:
  the byte array representing the java Date.
Throws:
  `java.sql.SQLException`

#### offsetDateTimeValue

    public java.time.OffsetDateTime offsetDateTimeValue()
                                                 throws java.sql.SQLException

Calls toOffsetDateTime to convert internal Oracle TIMESTAMPTZ to a Java OffsetDateTime without a connection object.

Returns:
  a Java OffsetDateTime
Throws:
  `java.sql.SQLException`

#### offsetDateTimeValue

    public java.time.OffsetDateTime offsetDateTimeValue​(java.sql.Connection conn)
                                                 throws java.sql.SQLException

Calls toOffsetDateTime to convert internal Oracle TIMESTAMPTZ to a Java OffsetDateTime with a connection object.

Parameters:
  `a` - JDBC Connection object
Returns:
  a Java OffsetDateTime
Throws:
  `java.sql.SQLException`

#### zonedDateTimeValue

    public java.time.ZonedDateTime zonedDateTimeValue()
                                               throws java.sql.SQLException

Calls toZonedDateTime to convert internal Oracle TIMESTAMPTZ to a Java ZonedDateTime.

Returns:
  a Java ZonedDateTime
Throws:
  `java.sql.SQLException`

#### localDateTimeValue

    public java.time.LocalDateTime localDateTimeValue()
                                               throws java.sql.SQLException

Calls toLocalDateTime to convert internal Oracle TIMESTAMPTZ to a Java LocalDateTime.

Returns:
  a Java LocalDateTime
Throws:
  `java.sql.SQLException`

#### dateValue

    public java.sql.Date dateValue​(java.sql.Connection conn)
                            throws java.sql.SQLException

Calls toDate to convert internal Oracle TIMESTAMPTZ to a Java Date.

Parameters:
  `a` - JDBC Connection object
Returns:
  a Java Date
Throws:
  `java.sql.SQLException`

#### timeValue

    public java.sql.Time timeValue​(java.sql.Connection conn)
                            throws java.sql.SQLException

Calls toTime to convert internal Oracle Date to a Java Time.

Returns:
  a Java Time value
Throws:
  `java.sql.SQLException`

#### getTimeZone

    public java.util.TimeZone getTimeZone()
                                   throws java.sql.SQLException

Returns:
  the TimeZone of this value
Throws:
  `java.sql.SQLException`

#### of

    public static TIMESTAMPTZ of​(java.time.ZonedDateTime zdt)
                          throws java.sql.SQLException

Creates TIMESTAMPTZ from the ZonedDateTime.

Parameters:
  `zdt` - ZonedDateTime object
Returns:
  TIMESTAMPTZ object
Throws:
  `java.sql.SQLException`

#### toZonedDateTime

    public java.time.ZonedDateTime toZonedDateTime()
                                            throws java.sql.SQLException

Converts TIMESTAMPTZ to ZonedDateTime.

Returns:
  ZonedDateTime object.
Throws:
  `java.sql.SQLException`

#### toLocalDateTime

    public java.time.LocalDateTime toLocalDateTime()
                                            throws java.sql.SQLException

Converts TIMESTAMPTZ to LocalDateTime.

Returns:
  LocalDateTime object.
Throws:
  `java.sql.SQLException`

#### toLocalDateTime

    public static java.time.LocalDateTime toLocalDateTime​(byte[] timestamptz)
                                                   throws java.sql.SQLException

Converts TIMESTAMPTZ to LocalDateTime.

Parameters:
  `timestamptz` - TIMESTAMPTZ datum
Returns:
  LocalDateTime object.
Throws:
  `java.sql.SQLException`

#### toZonedDateTime

    public static java.time.ZonedDateTime toZonedDateTime​(byte[] timestamptz)
                                                   throws java.sql.SQLException

Converts TIMESTAMPTZ to ZonedDateTime.

Returns:
  ZonedDateTime object.
Throws:
  `java.sql.SQLException`

#### toOffsetTime

    public java.time.OffsetTime toOffsetTime()
                                      throws java.sql.SQLException

Converts a TIMESTAMPTZ to an OffsetTime

Parameters:
  `timestamptz` - a byte array
Returns:
  OffsetTime representing the TIMESTAMPTZ
Throws:
  `java.sql.SQLException`

#### of

    public static TIMESTAMPTZ of​(java.time.OffsetDateTime odt)
                          throws java.sql.SQLException

Creates TIMESTAMPTZ from the OffsetDateTime.

Parameters:
  `odt` - OffsetDateTime object
Returns:
  TIMESTAMPTZ object
Throws:
  `java.sql.SQLException`

#### of

    public static TIMESTAMPTZ of​(java.sql.Connection conn,
                                 java.time.LocalDateTime ldt)
                          throws java.sql.SQLException

Creates TIMESTAMPTZ from the LocalDateTime.

Parameters:
  `conn` - Connection object
  `ldt` - LocalDateTime object
Returns:
  TIMESTAMPTZ object
Throws:
  `java.sql.SQLException`

#### toOffsetDateTime

    public java.time.OffsetDateTime toOffsetDateTime()
                                              throws java.sql.SQLException

Converts TIMESTAMPTZ to OffsetDateTime.

Returns:
  OffsetDateTime object.
Throws:
  `java.sql.SQLException`

#### toJdbc

    public java.lang.Object toJdbc()
                            throws java.sql.SQLException

Returns the JDBC representation of the timestamptz object

Specified by:
  `toJdbc` in class `Datum`
Returns:
  an object containing the JDBC value
Throws:
  `java.sql.SQLException` - if conversion to JDBC representation results in an error

#### makeJdbcArray

    public java.lang.Object makeJdbcArray​(int arraySize)

Returns a JDBC array representation of the datum

Specified by:
  `makeJdbcArray` in class `Datum`
Parameters:
  `arraySize` - size of the array
Returns:
  an object containing the JDBC array value

#### isConvertibleTo

    public boolean isConvertibleTo​(java.lang.Class<?> cls)

Determines if the object can be converted to a particular class

Specified by:
  `isConvertibleTo` in class `Datum`
Parameters:
  `cls` - Class to convert to
Returns:
  true, if conversion to cls is permitted false, if conversion to cls is not permitted